package nuxeoautomationtest;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.nuxeo.ecm.automation.client.Constants;
import org.nuxeo.ecm.automation.client.jaxrs.impl.HttpAutomationClient;
import org.nuxeo.ecm.automation.client.model.Documents;
import org.nuxeo.ecm.automation.client.Session;
import org.nuxeo.ecm.automation.client.model.Document;
import org.nuxeo.ecm.automation.client.model.FileBlob;
import org.nuxeo.ecm.automation.client.model.PropertyMap;

public class NuxeoAutomationTest {

    private Session getSession (String user, String passwd) throws Exception{
    HttpAutomationClient client
                = new HttpAutomationClient(
                        "http://msv.wara.de:8888/nuxeo/site/automation");
        Session session = client.getSession(user, passwd);
        return session;
    }

    public void setDoc() throws Exception {
        Session session = this.getSession("Administrator", "baw,dsf!");
        // get the root
        Document root = (Document) session.newRequest("Document.Fetch").set("value", "/").execute(); 
        // create a file document
        session.newRequest("Document.Create").
                setInput(root).set("type", "File").
                set("name", "testdatei3").
                set("properties", "dc:title=Testdatei3").execute();
        
        File file = new File("/tmp/bla.odt");
        FileBlob fb = new FileBlob(file);
        fb.setMimeType("text/xml");
        // uploading a file will return null since we used HEADER_NX_VOIDOP
        session.newRequest("Blob.Attach").
                setHeader(Constants.HEADER_NX_VOIDOP, "true").
                setInput(fb).set("document", "/testdatei").execute();
    }
    
    public void getDoc() throws Exception {

        Session session = this.getSession("rse", "rse");

        StringBuffer search = new StringBuffer();

        search.append("SELECT * FROM Document WHERE ");
        search.append("ecm:tag ILIKE 'user%'");
        search.append(" OR ");
        search.append("ecm:tag ILIKE '%'");

        Documents docs
                = (Documents) session.newRequest("Document.Query").
                set("query", search.toString()).
                setHeader(Constants.HEADER_NX_SCHEMAS, "*").execute();

        for (Document doc : docs) {
            doc.getVersionLabel();
            System.out.printf("#################################################################\n");
            System.out.printf("#                      doc-version: %s\n",doc.getVersionLabel());
            System.out.printf("#################################################################\n");

            FileBlob fb = (FileBlob) session.getFile("http://msv.wara.de:8888/nuxeo/nxbigfile/default/" + doc.getId());

            InputStream is = fb.getStream();

            System.out.println(convertStreamToString(is));
           }
    }

    private String convertStreamToString(java.io.InputStream is) {
        java.util.Scanner s = new java.util.Scanner(is).useDelimiter("\\A");
        return s.hasNext() ? s.next() : "";
    }

    public static void main(String[] args){
    NuxeoAutomationTest nat = new NuxeoAutomationTest();
        try {
            nat.getDoc();
            nat.setDoc();
        } catch (Exception ex) {
            Logger.getLogger(NuxeoAutomationTest.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
}
